//+------------------------------------------------------------------+
//| BOLLINGER+STARC (BollStarc-TC.mq4)                                    |
//| Copyright  2006                                                 |
//| http://www.                                                      |
//+------------------------------------------------------------------+
//+sigArrows
#property copyright "Copyright  2006, "
#property link "http://www.   "



#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1  DimGray
#property indicator_color2  Yellow 
#property indicator_color3  Yellow
#property indicator_color4  RoyalBlue 
#property indicator_color5  RoyalBlue
#property indicator_color6  LimeGreen 
#property indicator_color7  Red





extern int    BB_Period        = 20;
extern double BB_Deviations    = 2;
extern int    MA_Period        = 13; 
extern int    ATR_Period       = 21; 
extern double KATR             = 2.5;
extern int    Shift            = 0; 
extern double ArrowDistance    = 0.3;
extern int    arrowthickness   = 2;

extern string note             = "turn on Alert = true; turn off = false";
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = true;
extern bool   alertsEmail      = false;
extern string soundfile        = "alert3.wav";



double MovingBuffer[];
double UpperBuffer[];
double LowerBuffer[];
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double SigBufferUp[];
double SigBufferDn[];
double trend[];





int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,MovingBuffer);  SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(1,UpperBuffer);   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(2,LowerBuffer);   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(3,ExtMapBuffer1); SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(4,ExtMapBuffer2); SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(5,SigBufferUp);   SetIndexStyle(5,DRAW_ARROW,0,arrowthickness); SetIndexArrow(5,241);
   SetIndexBuffer(6,SigBufferDn);   SetIndexStyle(6,DRAW_ARROW,0,arrowthickness); SetIndexArrow(6,242);
   SetIndexBuffer(7,trend);

  return(0);
}


int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
         
    for(i=limit; i>=0; i--)
    {
    MovingBuffer[i]    = iMA(NULL,0,MA_Period,Shift,MODE_EMA,PRICE_CLOSE,i);
    UpperBuffer[i]     = MovingBuffer[i] + (KATR * iATR(NULL,0,ATR_Period,i+Shift));
    LowerBuffer[i]     = MovingBuffer[i] - (KATR * iATR(NULL,0,ATR_Period,i+Shift));
    ExtMapBuffer1[i]   = iBands(NULL,0,BB_Period,BB_Deviations,0,PRICE_CLOSE,MODE_UPPER,i);
    ExtMapBuffer2[i]   = iBands(NULL,0,BB_Period,BB_Deviations,0,PRICE_CLOSE,MODE_LOWER,i);
    double SigDistance = ArrowDistance*(KATR * iATR(NULL,0,ATR_Period,i+Shift));
 
        trend[i] = trend[i+1];
        
    if (ExtMapBuffer1[i+1] < UpperBuffer[i+1] && ExtMapBuffer2[i+1] >= LowerBuffer[i+1] &&
        ExtMapBuffer2[i] < LowerBuffer[i] && MovingBuffer[i+1] < MovingBuffer[i]) trend[i] = 1;
           
  
    if (ExtMapBuffer1[i+1] <= UpperBuffer[i+1] && ExtMapBuffer2[i+1] > LowerBuffer[i+1] &&
        ExtMapBuffer1[i] > UpperBuffer[i] && MovingBuffer[i+1] > MovingBuffer[i]) trend[i] = -1;
            
         SigBufferUp[i] = EMPTY_VALUE;
         SigBufferDn[i] = EMPTY_VALUE;
         if (trend[i]  !=trend[i+1])
         if (trend[i]   == 1)
               SigBufferUp[i] = ExtMapBuffer2[i] - SigDistance;
         else  SigBufferDn[i] = ExtMapBuffer1[i] + SigDistance;
         }
         
         if (alertsOn)
      {
      if (alertsOnCurrent)
           int whichBar = 1;
      else     whichBar = -1;

         //
         //
         //
         //
         //
         
         if (trend[whichBar] != trend[whichBar+1])
         if (trend[whichBar] == 1)
                doAlert("uptrend"); 
              
        else  doAlert("downtrend");       
   }
   
   return(0);
}
//+------------------------------------------------------------------+

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," BollStarc-TC_Sig ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," BollStarc-TC_Sig "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}

